package question1;
import java.util.List;
import java.util.Vector;
import java.lang.reflect.Array;
import java.io.Serializable;

public class Agregateur implements AgregateurI{
  private List<Message> messages;
  private List<Message> sauvegarde;
  private int tailleMax;
  private String nom;
  /** Constructeur d'un l'agregateur.
   * @param size la taille, le nombre de messages souhait
   */
  public Agregateur(String nom, int tailleMax){
    this.nom = nom;
    this.messages   = new Vector<Message>(tailleMax);
    this.tailleMax = tailleMax;
    this.sauvegarde = new Vector<Message>();
  }
  /** Rception d'un message.
   * @param message
   * @throws Exception si le nombre de messages attendus est dj atteint, le message est sauvegard
   */
  public void recevoir(Message message) throws Exception{
    if(messages.size()==this.tailleMax){
      sauvegarde.add(message);
      throw new Exception("le nombre de messages attendus est dj atteint !");
    }else{
      messages.add(message);
    }
  }
  
  /** Lecture des messages envoys.
   * @return une table contenant tous les messages reus.
   * @throws Exception si la lecture intervient avant le nombre de messages escompts
   */
  public Message[] lireMessages() throws Exception{
    if(messages.size()==this.tailleMax){
      //Message[] msg = messages.toArray((Message[])Array.newInstance(messages.iterator().next().getClass(),0));
      Message[] msg = messages.toArray(new Message[0]);
      messages.clear();
      return msg;
    }else{
      throw new Exception("la lecture intervient avant le nombre de messages escompts !");
    }
  }
  
  /** Affecte la taille de l'agregateur.
   * @param taille la taille souhaite
   * @throws Exception si parmi les messages envoys certains n'ont pas t lus 
   */
  public void initialiser(int taille) throws Exception{
     if(messages.size()==this.tailleMax){
      }
  }
  
  /** Effacement des messages. Les messages dj reus sont effacs.
   * @throws Exception une exception est lve, si des messages non lus ont t effacs
   */
  public  void vider() throws Exception{
  }
  
  /** Annule l'opration clear antrieure.
   * @throws Exception si l'appel de clear ne prcdait pas l'appel de undo
   */
  public void annuler() throws Exception{
  }
  
  
}
