package question2;

import java.rmi.*;
import java.rmi.registry.*;
import java.util.Random;
import java.io.Serializable;
/** 
 * start java -cp . -Djava.rmi.server.codebase=http://localhost:8086/ -Djava.security.policy=java.policy question2.SplitterReceive
 */
public class SplitterReceive{

  public static void main(String[] args) throws Exception {

    System.setSecurityManager(new RMISecurityManager());
    System.out.print("SplitterReceiver ");
    while(true){
      
      //SplitterRMII<Serializable> splitter = (SplitterRMII)Naming.lookup("rmi://localhost:1099/splitter"); 
      SplitterRMII<String> splitter = (SplitterRMII)Naming.lookup("rmi://splittermain.cnam.fr:1099/splitter");
      boolean tableVide = true;
      while(tableVide){
        try{
          tableVide = splitter.unreadMessages().size()==0;
          if(tableVide){
            Thread.sleep(1000);  
          }
        }catch(Exception e){
        }finally{
          System.out.print(".");
        }
      }
      
      int numberOfMessages = splitter.unreadMessages().size();
      Random random = new Random();
      //for(int index = 0; index<numberOfMessages;index++){
      while(splitter.unreadMessages().size()>0){
        try{
          int index = random.nextInt(numberOfMessages+2);
          // +2 pour avoir des exceptions alatoires ...
          System.out.print("lecture en " + index);
          System.out.print(" de " + splitter.get(index));
          Thread.sleep(2000);
        }catch(Exception e){
          System.out.print(" exception : " + e.getMessage());
        }finally{
          System.out.println();
        }
      }
    }
  }
}

