package question3;

import java.lang.management.ManagementFactory;
import javax.management.MBeanServer;
import javax.management.MBeanServerInvocationHandler;
import javax.management.ObjectName;
import java.util.Set;

public class TestSplitter extends junit.framework.TestCase{
 
static{
  new Thread(new Runnable(){
    public void run(){
      try{
        MBeanServer mbs = ManagementFactory.getPlatformMBeanServer();
        ObjectName beanName = new ObjectName( "SplitterTest:name=splitter" );
        //SplitterMBean<String> mbean = new Splitter<String>(new question2.SplitterRMI<String>(new question1.Splitter<String>()));
    
        SplitterMBean<String> mbean = new Splitter<String>(new question1.Splitter<String>());
        mbs.registerMBean(mbean, beanName);
        Thread.sleep(5*1000*60); // le temps d'installer jconsole
      }catch(Exception e){
      }
    }}).start();
}
  
  public void testScenario1() throws Exception{
    //final SplitterI<String> s = new Splitter<String>();
    Thread.sleep(1000*60); // le temps d'installer jconsole
    MBeanServer mbs = ManagementFactory.getPlatformMBeanServer();
    ObjectName beanName = new ObjectName( "SplitterTest:name=splitter" );
    final SplitterMBean<String> s = (SplitterMBean<String>)MBeanServerInvocationHandler.newProxyInstance(mbs, beanName, SplitterMBean.class, true); 
    s.send("zero","un","deux","trois","quatre"); // envoi dune table de 5 String
    String msg = s.get(2);                 // lecture de llment (msg) dindice 2
    assertEquals("deux",msg);
    Set<Integer> set = s.unreadMessages();
    assertTrue(set.contains(0));assertTrue(set.contains(1));
    assertTrue(set.contains(3));assertTrue(set.contains(4));
    assertEquals(set.size(),4);// soit 4 lments  lire
    
    assertTrue(s.get(4).equals("quatre"));
    assertTrue(s.unreadMessages().size()==3);
    try{
      // nouvel envoi alors qu'il reste des lments  lire
      s.send("test"); 
      fail("une exception est attendue ici ...");
    }catch(Exception e){}
    for(int i : s.unreadMessages()){ // pour tous les messages non lus
      String v = s.get(i);
    }
    String v = s.get(2);              // une deuxime lecture est possible
    assertTrue(s.unreadMessages().size()==0);
    s.send("test0","test1");
    assertTrue(s.unreadMessages().size()==2);
    try{
      // clear() alors qu'il reste des lments  lire
      s.clear();
      fail("une exception est attendue ici ...");
    }catch(Exception e){}
  }

  
  public void testScenario2() throws Exception{
//     final SplitterI<String> s = new Splitter<String>();
    MBeanServer mbs = ManagementFactory.getPlatformMBeanServer();
    ObjectName beanName = new ObjectName( "SplitterTest:name=splitter" );
    final SplitterMBean<String> s = (SplitterMBean<String>)MBeanServerInvocationHandler.newProxyInstance(mbs, beanName, SplitterMBean.class, true); 
 
    try{
      // clear() alors qu'il reste des lments  lire
      s.get(0);
      fail("une exception est attendue ici ...");
    }catch(Exception e){
    }
    s.send("a","b","c","d");
    try{
      // clear() alors qu'il reste des lments  lire
      s.clear();
      fail("une exception est attendue ici ...");
    }catch(Exception e){
    }
    try{
      // get alors qu'il n'y a rien  lire   
        s.get(0);
        fail("une exception est attendue ici ...");
    }catch(Exception e){
    }
    s.clear();
    try{
      // aucun envoi n'a eu lieu
      s.unreadMessages(); 
      fail("une exception est attendue ici ...");
    }catch(Exception e){
    }
  }
}
