package question1;

public class Replier extends Thread implements IReplier{
    private IChannel requestChannel;
    private IMessage messageReceived;
    private long    timeout;

    public Replier(IChannel requestChannel, long timeout){
        this.requestChannel = requestChannel;
        this.timeout = timeout;
        this.setPriority(Thread.MAX_PRIORITY);
        this.start();
    }

    public IMessage getTheLastMessageReceived(){
        return messageReceived;
    }

    public void run(){
        while(!interrupted()){
            try{
                //System.out.println("attente d'un message..");
                this.messageReceived = requestChannel.get(timeout);
                //System.out.println("message.. reu" + messageReceived);
                IMessage returnMessage = new Message(messageReceived);
                messageReceived.getReplyChannel().put(returnMessage);
            }catch(InterruptedException ie){
                System.err.println("arrt: dlai de garde chu..");
            }
        }
    }


}
