package question1;

import java.util.concurrent.*;

public class Requestor  implements IRequestor{
   private IChannel requestChannel;
   private IChannel replyChannel;
   private IMessage messageSent, messageReceived;
   private Object  synchro;
   
   public Requestor(IChannel requestChannel, IChannel replyChannel){
     this.requestChannel = requestChannel;
     this.replyChannel = replyChannel;
     this.synchro = new Object();
   }
   
   public void send(IMessage message) {
     this.requestChannel.put(message);
     this.messageSent = message;
   }
   
   public IMessage receive(long timeout)throws InterruptedException{
     this.messageReceived = replyChannel.get(timeout);
     //synchronized(synchro){ synchro.notify();}
     return messageReceived;
   }
   
   public IMessage getTheLastMessageSent() {
     return messageSent;
   }

   public IMessage getTheLastMessageReceived(){
     try{
       synchronized(synchro){synchro.wait();}
    }catch(Exception e){}
     return messageReceived;
   }
}
