package question1;


public class Replier extends Thread implements Replier{

  private MakeContent makeContent = Replier.none;
  private Channel requestChannel;
  private Message messageReceived;
  private long    timeout;
  
  public ReplierImpl(Channel requestChannel, long timeout){
    this.requestChannel = requestChannel;
    this.timeout = timeout;
    this.setPriority(Thread.MAX_PRIORITY);
    this.start();
  }
  
  public Message getTheLastMessageReceived(){
    return messageReceived;
  }
  
  public void setMakeContent(MakeContent m){
    this.makeContent = m;
  }
  
  public void run(){
    try{
      System.out.println("Replier  a dmarr...");
      while(true){
        this.messageReceived = requestChannel.receive(timeout);
        System.out.println("Reception de " + messageReceived);
        String result = makeContent.execute(messageReceived.getContent());
        Message returnMessage = new MessageImpl(result);
        messageReceived.getReplyChannel().send(returnMessage);
      }
    }catch(InterruptedException ie){
       System.out.println("arrt au dlai de garde chu..");
    }
  }      
  
}
