package question3;
import javax.management.*;
import question1.Replier;
import question1.Message;
import java.util.*;

public class JmxChannel
extends NotificationBroadcasterSupport
implements JmxChannelMBean{

    private question1.Channel channel;

    private static long number;

    public JmxChannel(question1.Channel channel){
        this.channel = channel;
    }

    public void send(Message message){
        sendNotification(new Notification("Channel.send",this,number++,message.toString()));
        channel.send(message);

    }

    public Message receive(long timeOut) throws InterruptedException{
        try{
            Message message = channel.receive(timeOut);
            sendNotification(new Notification("Channel.receive",this,number++,message.toString()));
            return message;
        }catch(InterruptedException ie){
            sendNotification(new Notification("Channel.receive:InterruptedException",this,number++,ie.getMessage()));
            throw ie;
        }

    }

    public String toString(){
        return channel.toString();
    }

}
