package question1;

import java.util.Iterator;
import java.util.List;
// import java.util.concurrent.*;
// import java.util.Random;

public class TestSplitter extends junit.framework.TestCase{
 
  public void testScenario1() throws Exception{
    SplitterI splitter = new Splitter();
    splitter.send(new String[]{"un","deux","trois"}); // envoi dune table de 3 elements
    assertEquals(3,splitter.unreadMessages().length);// soit 3 lments  lire
    Iterator<String> iterator = splitter.iterator();
    assertEquals("trois",iterator.next());
    assertEquals(2,splitter.unreadMessages().length);// soit 2 lments encore  lire
    iterator = splitter.iterator();
    assertEquals("deux",iterator.next());
    
    try{
      splitter.send(new String[]{"test"}); // envoi alors qu'il reste au moins un lment  lire
      fail("une exception est attendue ici ...");
    }catch(Exception e){
    }
    assertTrue(iterator.hasNext());
    assertEquals("un",iterator.next());
    assertFalse(iterator.hasNext());
    
  }
  
  public void testScenario2() throws Exception{
    SplitterI splitter = new Splitter();
    try{
      // pas de messages  lire
      String elt = splitter.iterator().next();
      fail("une exception est attendue ici ...");
    }catch(Exception e){
    }
    splitter.send(new String[]{"a","b","c","d"});
    try{
      // send alors qu'il reste des lments  lire
      splitter.send(new String[]{"e","f"});
      fail("une exception est attendue ici ...");
    }catch(Exception e){
    }
  
  }
  
  // public void testScenario3() throws Exception{
    // final SplitterI<String> s = new Splitter<String>();
    // s.send("a","b","c","d");
    // String msg = s.get(0);assertEquals("a",msg);
    // msg = s.get(1);assertEquals("b",msg);
    // msg = s.get(2);assertEquals("c",msg);
    // msg = s.get(3);assertEquals("d",msg);
    // assertEquals(0,s.unreadMessages().size());
    // s.send("a","b");
    // assertEquals(2,s.unreadMessages().size());
    // s.get(1); s.get(1);
    // assertEquals(1,s.unreadMessages().size());
    // s.get(0);
    // assertEquals(0,s.unreadMessages().size());
    // s.send("a","b","c","d","e");
    // assertEquals(5,s.unreadMessages().size());
    // msg = s.get(0);assertEquals("a",msg);
    // msg = s.get(1);assertEquals("b",msg);
    // msg = s.get(2);assertEquals("c",msg);
    // msg = s.get(3);assertEquals("d",msg);
    // msg = s.get(4);assertEquals("e",msg);
    // assertEquals(0,s.unreadMessages().size());
  // }
  
  // private static class ThreadTestUnreadMessages implements Runnable{
    // private SplitterI<String> s;
    // public ThreadTestUnreadMessages(SplitterI<String> splitter){
      // this.s = splitter;
    // }
    // public void run(){
      // try{
        // while(s.unreadMessages().size()>0){
          // Set<Integer> unread = s.unreadMessages();
          // System.out.println("s.unreadMessages() : " + unread);
          // Thread.sleep(100);
        // }
      // }catch(Exception e){
        // e.printStackTrace();
      // }
    // }
  // }
  
  // private static class ThreadTestGetMessages implements Runnable{
    // private SplitterI<String> s;
    // private Random random= new Random();
    // public ThreadTestGetMessages(SplitterI<String> splitter){
      // this.s = splitter;
    // }
    
    // public void run(){
      // try{
        // while(true){
          // String msg = s.get(random.nextInt(5));
          // System.out.println("msg lu : " + msg);
          // Thread.sleep(10);
        // }
      // }catch(Exception e){
        
      // }
    // }
  // }
  

  // public void testScenario4() throws Exception{
    // ExecutorService pool = Executors.newFixedThreadPool(20);
    // final SplitterI<String> s = new Splitter<String>();
    // s.send("a","b","c","d");
    // pool.execute(new ThreadTestUnreadMessages(s));
    // pool.execute(new ThreadTestUnreadMessages(s));
    // pool.execute(new ThreadTestUnreadMessages(s));
    // pool.execute(new ThreadTestUnreadMessages(s));
    
    // pool.execute(new ThreadTestGetMessages(s));
    // pool.execute(new ThreadTestGetMessages(s));
    // pool.execute(new ThreadTestGetMessages(s));
    // pool.execute(new ThreadTestGetMessages(s));
    // pool.execute(new ThreadTestGetMessages(s));
    // pool.execute(new ThreadTestGetMessages(s));
    // pool.execute(new ThreadTestGetMessages(s));
    // pool.execute(new ThreadTestGetMessages(s));
    // Thread.sleep(10*1000);
    // pool.shutdown();
  // }
    
  
}
