package question2;
import question1.*;

import java.rmi.*;
import java.rmi.registry.*;
import java.io.Serializable;

/** 
 * c:/start rmiregistry
 J:\NSY102\examen_juin_2011>start java -cp . ServeurWeb8086
 J:\NSY102\examen_juin_2011>start java -cp . -Djava.security.policy=java.policy -Djava.rmi.server.codebase=http://localhost:8086/ question2.SplitterMain
 */
public class SplitterMain{

 public static void main(String[] args) throws Exception {
    System.setSecurityManager(new RMISecurityManager());
    
    Remote splitter_stub = new SplitterRMI<Serializable>(new Splitter<Serializable>());
    Naming.rebind("splitter",splitter_stub); // lannuaire par dfaut c.f. rmiregistry
    
    System.out.println("splittermain.cnam.fr, service splitter install");
  }
}