package question1;

import java.io.Serializable;

public interface AgregateurI extends Serializable{


  /** Rception d'un message.
   * @param message
   * @throws Exception si le nombre de messages attendus est atteint
   */
  void recevoir(Message message) throws Exception;
  
  /** Lecture des messages reus.
   * @return une table contenant tous les messages reus.
   * @throws Exception si la lecture intervient avant le nombre de messages escompts
   */
  Message[] lireMessages() throws Exception;

  /** Affecte la taille de l'agregateur.
   * @param taille la taille souhaite
   * @throws Exception si parmi les messages envoys certains n'ont pas t lus 
   */
  void initialiser(int taille) throws Exception;
  
  /** Effacement des messages. Les messages dj reus sont effacs.
   * @throws Exception une exception est lve, si des messages non lus ont t effacs
   */
  void vider() throws Exception;
  
  /** Annule l'opration "vider" antrieure.
   * @throws Exception si au moins un appel de vider ne prcdait pas l'appel de annuler
   */
  void annuler() throws Exception;
  
  
}
