package question2;


import java.rmi.*;
import java.rmi.registry.*;

public class SplitterSend3{
  /* start java -cp . -Djava.security.policy=java.policy -Djava.rmi.server.codebase=http://localhost:8086/ question2.SplitterSend3 */
  public static void main(String[] args) throws Exception {

    System.setSecurityManager(new RMISecurityManager());
    
    SplitterRMII<Class<?>> splitter = (SplitterRMII)Naming.lookup("splitter");

      try{
        splitter.clear();
      }catch(Exception e){}
      
      splitter.send(Integer.class,Boolean.class,SplitterRMI.class,SplitterRMII.class,java.io.Serializable.class,SplitterSend3.class);
      
      while(splitter.unreadMessages().size()>0){
        System.out.println(splitter.unreadMessages().size() + " message(s) non lu(s)," + " leur(s) indice(s) : " + splitter.unreadMessages());
        Thread.sleep(500);
      }
      
  }
}
