package question3;

import java.rmi.registry.LocateRegistry;
import javax.management.MBeanServer;
import javax.management.MBeanServerInvocationHandler;
import javax.management.ObjectName;
import javax.management.remote.JMXServiceURL;
import javax.management.remote.JMXConnectorServer;
import javax.management.remote.JMXConnectorServerFactory;
import java.lang.management.ManagementFactory;


public class SplitterAgent{
  
  public static void installSplitter() throws Exception{
    MBeanServer mbs = ManagementFactory.getPlatformMBeanServer();
    ObjectName beanName = new ObjectName( "Splitter:name=splitter" );
    //SplitterMBean<String> mbean = new Splitter<String>(new question2.SplitterRMI<String>(new question1.Splitter<String>()));
    
    SplitterMBean<String> mbean = new Splitter<String>(new question1.Splitter<String>());
    mbs.registerMBean(mbean, beanName);
    
//     LocateRegistry.getRegistry(1099);
//     JMXServiceURL url = new JMXServiceURL("service:jmx:rmi:///jndi/rmi://localhost:1099/splitter");
//     JMXConnectorServer cs = JMXConnectorServerFactory.newJMXConnectorServer(url, null, mbs);
//     cs.start();
    
  }
  
  public static void testNotification() throws Exception{
    MBeanServer mbs = ManagementFactory.getPlatformMBeanServer();
    ObjectName beanName = new ObjectName( "Splitter:name=splitter" );
    
    SplitterMBean<String> s = (SplitterMBean<String>)MBeanServerInvocationHandler.newProxyInstance(mbs, beanName, SplitterMBean.class, true);
    s.send("zero","un","deux","trois","quatre");
 
  }
    
    
  public static void main(String[] args)throws Exception {
    installSplitter();
    Thread.sleep(1000*30); // le temps d'installer 2 jconsole
     
    testNotification();
    
    Thread.sleep(1000*15*60);
  }
}