package question1;

public class TestReturnAddress extends junit.framework.TestCase{

  // selon http://www.enterpriseintegrationpatterns.com/ReturnAddress.html
	public void testReturnAddressPattern() throws Exception{
	  // les canaux request, Reply1, Reply2
	  IChannel requestChannel = new Channel();
	  IChannel replyChannel_1 = new Channel();
	  IChannel replyChannel_2 = new Channel();
	  
	  // Requestor 1 et Requestor 2
	  Requestor requestor_1 = new Requestor();
	  Requestor requestor_2 = new Requestor();
	  
	  // Replier 
	  Replier replier = new Replier();

	  Message message1 = new MessageImpl("requestor 1", replyChannel_1);
	  Message message2 = new MessageImpl("requestor 2", replyChannel_2);

	  requestor_2.send(message2);
	  Thread.sleep(1000); // attente de une seconde
  	  Message received = requestor_2.receive(2000);
  	  assertEquals("requestor 2", received.getContent());
  	  
  	  requestor_1.send(message1);
	  Thread.sleep(1000); // attente de une seconde
  	  received = requestor_1.receive(2000);
  	  assertEquals("requestor 1", received.getContent());

  	  
	}
}

