package question1;

import java.util.concurrent.*;

public class RequestorImpl  implements Requestor{
   private Channel requestChannel;
   private Channel replyChannel;
   private Message messageSent, messageReceived;
   private Object  synchro;
   
   public RequestorImpl(Channel requestChannel, Channel replyChannel){
     this.requestChannel = requestChannel;
     this.replyChannel = replyChannel;
     this.synchro = new Object();
   }
   
       
   public void send(Message message) {
     this.requestChannel.send(message);
     this.messageSent = message;
   }
   
   public Message receive(long timeout)throws InterruptedException{
     this.messageReceived = replyChannel.receive(timeout);
     synchronized(synchro){ synchro.notify();}
     System.out.println("receive : " + messageReceived);
     return messageReceived;
   }
   
   public Message getTheLastMessageSent() {
     return messageSent;
   }

   public Message getTheLastMessageReceived(){
     try{
       synchronized(synchro){synchro.wait();}
    }catch(Exception e){}
     return messageReceived;
   }
}
