package question3;
import javax.management.*;

import question1.IMessage;
import java.util.*;

public class Channel
extends NotificationBroadcasterSupport
implements ChannelMBean{

    private question1.IChannel channel;

    private static long number;

    public Channel(question1.IChannel channel){
        this.channel = channel;
    }

    public void put(IMessage message){
        sendNotification(new Notification("Channel.put",this,number++,message.toString()));
        channel.put(message);

    }

    public IMessage get(long timeOut) throws InterruptedException{
        try{
            IMessage message = channel.get(timeOut);
            sendNotification(new Notification("Channel.get",this,number++,message.toString()));
            return message;
        }catch(InterruptedException ie){
            sendNotification(new Notification("Channel.get:InterruptedException",this,number++,ie.getMessage()));
            throw ie;
        }

    }

    public String toString(){
        return channel.toString();
    }

}
