package question1;


public interface AggregatorI{

  /** Envoi d'un message.
   * @param message
   * @throws Exception si le nombre de messages attendus est atteint
   */
  void send(String message) throws Exception;
  
  /** Lecture des messages envoys.
   * @return une table contenant tous les messages reus.
   * @throws Exception si la lecture intervient avant le nombre de messages escompts
   */
  String[] getMessages() throws Exception;
  
  /** Effacement de tous les messages.
   */
  void reset();
  
  /** Affecte une nouvelle taille de l'aggrgateur.
   * @throws Exception si l'aggrgateur n'est pas vide
   */
  void setSize(int size) throws Exception;

  /** Lecture du nombre d'lments envoys.
   */
  int getSent();
  
}
