package question1;

import java.util.Set;

public class TestAggregator extends junit.framework.TestCase{

    public void testScenario1() throws Exception{
        AggregatorI aggregator = new Aggregator(3);
        aggregator.send("trois");
        aggregator.send("deux");
        aggregator.send("un");
        String[] messages = aggregator.getMessages();
        assertTrue(messages[0].equals("un"));    
        assertTrue(messages[1].equals("deux"));
        assertTrue(messages[2].equals("trois")); 

        try{
            aggregator = new Aggregator(2);
            aggregator.send("deux");
            assertEquals(1, aggregator.getSent());
            messages = aggregator.getMessages();
            fail("une exception est attendue ici ...");
        }catch(Exception e){}
        try{
            aggregator.send("un");
            assertEquals(2, aggregator.getSent());
            messages = aggregator.getMessages();
            assertEquals(0, aggregator.getSent());
            assertTrue(messages[0].equals("un"));    
            assertTrue(messages[1].equals("deux"));
        }catch(Exception e){
            fail("une exception n'est pas attendue ici ...");
        }

        aggregator = new Aggregator(2);
        aggregator.setSize(3);
        aggregator.send("un");
        aggregator.send("deux");
        aggregator.send("trois");
        assertEquals(3, aggregator.getSent());
        messages = aggregator.getMessages();
        assertEquals(0, aggregator.getSent());
        try{
            aggregator.send("un");
            aggregator.setSize(3);
            fail("une exception est attendue ici ...");
        }catch(Exception e){}

    }
}
