package question2;
import question1.SplitterI;

import java.rmi.Remote;
import java.rmi.RemoteException;
import java.io.Serializable;
import java.util.Set;

public interface SplitterRMII<M extends Serializable> extends  Remote{

  void send(M... messages) throws RemoteException, Exception;
  
  M get(int index) throws RemoteException, Exception;

  void clear() throws RemoteException, Exception;
  
  Set<Integer> unreadMessages() throws RemoteException, Exception;
  
}
