package question2;


import java.rmi.*;
import java.rmi.registry.*;

public class SplitterSend{
  /* start java -cp . -Djava.security.policy=java.policy -Djava.rmi.server.codebase=http://localhost:8086/ question2.SplitterSend */
  public static void main(String[] args) throws Exception {

    System.setSecurityManager(new RMISecurityManager());
    
    //SplitterRMII<String> splitter = (SplitterRMII)Naming.lookup("rmi://splittermain.cnam.fr:1099/splitter");
    SplitterRMII<String> splitter = (SplitterRMII)Naming.lookup("rmi://localhost:1099/splitter");

      try{
        splitter.clear();
      }catch(Exception e){}
      
      splitter.send("zero","un","deux","trois","quatre");
      
      while(splitter.unreadMessages().size()>0){
        System.out.println(splitter.unreadMessages().size() + " message(s) non lu(s)," + " leur(s) indice(s) : " + splitter.unreadMessages());
        Thread.sleep(500);
      }
      
  }
}
